#include <stdio.h>
#include <assert.h>
#include "fbbitblt.h"
#include "libfb.h"

void
bb4to4( FB *f, unsigned short *dest, unsigned short *src, unsigned short x,
	unsigned short y, unsigned short w, unsigned short h,
	unsigned short p, unsigned short q )
{
	register unsigned short *dbase=dest+(((q*f->vinf.xres)+p)>>4)*4;
	register unsigned short *sbase=src+(((y*f->vinf.xres)+x)>>4)*4;
	unsigned short words_per_line = f->vinf.xres*f->vinf.bits_per_pixel/16;
	int i,j;

	assert((x%16)==0);
	assert((y%16)==0);
	assert((h%16)==0);
	assert((w%16)==0);
	assert((p%16)==0);
	assert((q%16)==0);

	for ( j=0; j<h; j++ )
	{
		for ( i=0; i<(w/16*f->vinf.bits_per_pixel) ; i++ )
		{
			dbase[i]=sbase[i];
		}
		dbase+=words_per_line;
		sbase+=words_per_line;
		/*getchar();*/
	}
}

void bitblt( FB *f, FBBLTPBLK *fbb )
{
	register unsigned short *dbase=fbb->d_form + (( fbb->d_ymin * fbb->d_nxln ) + ( ( fbb->d_xmin % 16 ) * fbb->d_nxwd ) >> 1);
	register unsigned short *sbase;
	unsigned short *dbase1;
	unsigned short pc;
	unsigned short op_tabidx,logicop=0;
	unsigned short *s,*d,*lsbase,*ldbase;
	unsigned short i,j;
	unsigned int snxline,dnxline;
	unsigned short snxword,dnxword;
	unsigned short s_xmax=fbb->s_xmin+fbb->b_wd-1;
	unsigned short d_xmax=fbb->d_xmin+fbb->b_wd-1;
	unsigned short lf_endmask[]={ 	0xFFFF, 0x7FFF, 0x3FFF, 0x1FFF,
					0x0FFF, 0x07FF, 0x03FF, 0x01FF,
					0x00FF, 0x007F, 0x003F, 0x001F,
					0x000F, 0x0007, 0x0003, 0x0001, 0x0000 };
	unsigned short *rt_endmask=&lf_endmask[1];
	unsigned short lendmsk=lf_endmask[fbb->d_xmin%16];
	unsigned short rendmsk=rt_endmask[d_xmax%16];
	unsigned short skew=((fbb->d_xmin%16)-(fbb->s_xmin%16)) & 0x000F;

	if ( fbb->s_ymin < fbb->d_ymin )
	{
		printf("fbbitblt: bottom to top\n");
		/* Blit bottom to top */

		/* Adjust sbase and dbase */

		dbase1 =fbb->d_form+((((fbb->d_ymin+fbb->b_ht-1)*f->vinf.xres)+fbb->d_xmin)>>4)*fbb->plane_ct;

		dbase += ( fbb->d_ymin * ( fbb->b_wd - 1 ) ) >> 1;

		printf("dbase1 is %p, dbase is %p\n",dbase1,dbase);
		dbase=dbase1;

		sbase=fbb->s_form+((((fbb->s_ymin+fbb->b_ht-1)*f->vinf.xres)+fbb->s_xmin)>>4)*fbb->plane_ct;
		printf("dbase is %p, d_form is %p, sbase is %p, s_form is %p\n",dbase,fbb->d_form,sbase,fbb->s_form);
		/* Set next line offsets */

		snxline = - (fbb->s_nxln>>1);
		dnxline = - (fbb->d_nxln>>1);

		/* Set next word offsets */

		snxword = fbb->s_nxwd>>1;
		dnxword = fbb->d_nxwd>>1;
	}
	else if ( fbb->s_ymin > fbb->d_ymin )
	{
		/* Blit top to bottom */

		/* Adjust sbase and dbase */

		dbase=fbb->d_form+(((fbb->d_ymin*f->vinf.xres)+fbb->d_xmin)>>4)*fbb->plane_ct;
		sbase=fbb->s_form+(((fbb->s_ymin*f->vinf.xres)+fbb->s_xmin)>>4)*fbb->plane_ct;

		/* Set next line offsets */

		snxline = fbb->s_nxln>>1;
		dnxline = fbb->d_nxln>>1;

		/* Set next word offsets */

		snxword = fbb->s_nxwd>>1;
		dnxword = fbb->d_nxwd>>1;
	}
	else if ( fbb->s_xmin < fbb->d_xmin )
	{
		/* Blit top to bottom, right to left */

		/* Adjust sbase and dbase */

		dbase=fbb->d_form+(((fbb->d_ymin*f->vinf.xres)+(fbb->d_xmin+fbb->b_wd-1))>>4)*fbb->plane_ct;
		sbase=fbb->s_form+(((fbb->s_ymin*f->vinf.xres)+(fbb->s_xmin+fbb->b_wd-1))>>4)*fbb->plane_ct;

		/* Set next line offsets */

		snxline = fbb->s_nxln>>1;
		dnxline = fbb->d_nxln>>1;

		/* Set next word offsets */

		snxword = - (fbb->s_nxwd>>1);
		dnxword = - (fbb->d_nxwd>>1);
	}
	else
	{
		/* Blit top to bottom, left to right */

		/* Adjust sbase and dbase */

		dbase=fbb->d_form+(((fbb->d_ymin*f->vinf.xres)+fbb->d_xmin)>>4)*fbb->plane_ct;
		sbase=fbb->s_form+(((fbb->s_ymin*f->vinf.xres)+fbb->s_xmin)>>4)*fbb->plane_ct;

		/* Set next line offsets */

		snxline = fbb->s_nxln>>1;
		dnxline = fbb->d_nxln>>1;

		/* Set next word offsets */

		snxword = fbb->s_nxwd>>1;
		dnxword = fbb->d_nxwd>>1;
	}

	/* Blit each plane */

	for (	pc=1 ;
		pc<=fbb->plane_ct ;
		pc++,sbase+=fbb->s_nxpl>>1,dbase+=fbb->d_nxpl>>1 )
	{
		/* Calculate index into op_tab */

		op_tabidx = ( ( ( fbb->fg_col>>(pc - 1) ) & 0x0001 ) <<1 ) |
				(( fbb->bg_col>>(pc - 1) ) & 0x0001 );
		assert( op_tabidx<=3 );
		printf("op_tabidx is %hd\n",op_tabidx);
		/* Get logic op for this plane from op_tab */

		logicop = ((char *) &fbb->op_tab)[op_tabidx];
		assert( logicop<=15 );
		printf("logicop is %hd\n",logicop);
		/* Do for each line in the blit */

		for (	j=0,lsbase=sbase,ldbase=dbase ;
			j<fbb->b_ht ;
			j++,lsbase+=snxline,ldbase+=dnxline )
		{
			/*printf("lsbase is %p ldbase is %p snxline is %d dnxline is %d\n",lsbase,ldbase,snxline,dnxline);*/
			for (	i=0,s=lsbase,d=ldbase ;
				i<fbb->b_wd ;
				 )
			{
				switch(logicop)
				{
				case 0:	
				default: /*printf("d is %p, s is %p\n",d,s);*/
					*d=*s;
				}
				if (!( ++i & 15 ))
				{
					s+=snxword,d+=dnxword;
				}
			}
		}
	}
}
